/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: start.S 619 2014-03-18 06:10:27Z nmir-saito $
 */

/*
 *   ͥѤΥȥåץ⥸塼(ARM)
 */
#define TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */

#include "kernel_impl.h"
#include "target_asm.inc"

	ATEXT
	AALIGN(2)
	AGLOBAL(start)
ALABEL(start)
	/*
	 * ץå⡼ɤν
	 * ѡХ⡼ɡFIQ/IRQػ
	 */
	msr  cpsr_cxsf, #(CPSR_SVC AOR CPSR_FIQ_BIT AOR CPSR_IRQ_BIT) 

	/*
	 * åݥ󥿤ȡե졼ݥ󥿤ν
	 * sl(å¥쥸r10)ꤹɬפ뤫?
	 * gccϥǥեȤǤ-mapcsʤΤɬפʤ
	 */
	ldr  r0, =_kernel_istkpt
	ldr  sp, [r0]
	mov  fp, #0        /* ARM⡼ѥե졼ݥ(r11) */         
	mov  r7, #0        /* Thumb⡼ѥե졼ݥ    */

	/*
	 * hardware_init_hookθƤӽФ 0Ǥʤ
	 *
	 * åȥϡɥ˰¸ɬפʽ
	 * ϡhardware_init_hook ȤؿѰդ
	 */
	ldr   r0, =hardware_init_hook
	cmp   r0, #0x00
	movne lr, pc
	bxne  r0

ALABEL(start_1)

#ifndef TOPPERS_OMIT_BSS_INIT
	/*
	 *  bssΥꥢ
	 */
	ldr  r1, =BSS_START
	ldr  r2, =BSS_END
	cmp  r1,r2
	bhs  start_3
	mov  r0,#0
ALABEL(start_2)
	str  r0,[r1],#4
	cmp  r1, r2
	blo  start_2
#endif /* TOPPERS_OMIT_BSS_INIT */
	   
ALABEL(start_3)

#ifndef TOPPERS_OMIT_DATA_INIT
	/*
	 *  dataν(ROMб)
	 *  IDATA_START  IDATA_END ޤǤDATA_START ʹߤ
	 *  ԡ
	 */
	ldr  r1, =IDATA_START
	ldr  r3, =IDATA_END
	cmp  r1, r3
	bhs  start_5
	ldr  r2, =DATA_START
ALABEL(start_4)
	ldr  r0, [r1],#4
	str  r0, [r2],#4
	cmp  r1, r3
	blo  start_4
#endif /* TOPPERS_OMIT_DATA_INIT */

	/*
	 *  software_init_hook ƽФ0 Ǥʤ
	 *
	 *  եȥĶä˥饤֥ˤ˰¸ɬפʽ
	 *  ϡsoftware_init_hook ȤؿѰդ
	 *  褤
	 */
ALABEL(start_5)
	ldr   r0, =software_init_hook
	cmp   r0, #0x00
	movne lr, pc
	bxne  r0

	/*
	 * ͥư
	 */
ALABEL(start_6)
	bl   sta_ker
